CREATE TABLE veiculo (
    vei_placa VARCHAR(10),
    vei_modelo VARCHAR(25),
    vei_municipio VARCHAR(50),
    vei_uf VARCHAR(2),
    vei_cor VARCHAR(10),
    vei_ano INTEGER,
    vei_numero INTEGER,
    vei_renavam INTEGER(11),
    vei_chassi VARCHAR(17),
    vei_codigo INTEGER(11) PRIMARY KEY,
    vei_km_inicial NUMERIC(15,2),
    vei_tipo_combustivel INTEGER(2),
    vei_fk_proprietario_pes_codigo INTEGER(11),
    vei_fk_seguradora_pes_codigo INTEGER(11)
);

CREATE TABLE produto_frota (
    prf_codigo SERIAL PRIMARY KEY,
    prf_fk_pro_codigo INTEGER(11),
    prf_fk_cag_codigo SERIAL
);

CREATE TABLE apontamento_veiculo_uso (
    avu_codigo SERIAL PRIMARY KEY,
    avu_km_inicial NUMERIC(15,2),
    avu_km_final NUMERIC(15,2),
    avu_data_disponibilidade_inicial DATE,
    avu_data_disponibilidade_final DATE,
    avu_observacao TEXT,
    avu_date_insert TIMESTAMP,
    avu_user_insert TIMESTAMP,
    avu_date_update VARCHAR(30),
    avu_user_update VARCHAR(30),
    avu_fk_motorista_pes_codigo INTEGER(11),
    avu_fk_vei_codigo INTEGER(11),
    avu_data_hora_uso_inical TIMESTAMP,
    auv_data_hora_uso_final TIMESTAMP
);

CREATE TABLE categoria_gasto (
    cag_codigo SERIAL PRIMARY KEY,
    cag_descricao VARCHAR(40),
    cag_date_insert TIMESTAMP,
    cag_user_insert VARCAHR(30),
    cag_date_update TIMESTAMP,
    cag_user_update VARCAHR(30)
);

CREATE TABLE apontamento_veiculo_gasto (
    avg_codigo INTEGER(11) PRIMARY KEY,
    avg_descricao TEXT,
    avg_date_insert TIMESTAMP,
    avg_user_insert TIMESTAMP,
    avg_date_update TIMESTAMP,
    avg_user_update TIMESTAMP,
    avg_fk_vei_codigo INTEGER(11),
    avg_fk_responsavel_pes_codigo INTEGER(11)
);

CREATE TABLE apontamento_veiculo_gasto_item (
    avgi_quantidade INTEGER(11),
    avgi_date_insert TIMESTAMP,
    avgi_user_insert VARCHAR(30),
    avgi_codigo INTEGER(11) PRIMARY KEY,
    avgi_date_update TIMESTAMP,
    avgi_user_update VARCHAR(30),
    avgi_valor_unitaro NUMERIC(15,2),
    avgi_fk_avg_codigo INTEGER(11),
    avgi_fk_prf_codigo SERIAL
);
 
ALTER TABLE veiculo ADD CONSTRAINT FK_veiculo_1
    FOREIGN KEY (vei_fk_proprietario_pes_codigo???)
    REFERENCES ??? (???)
    ON DELETE RESTRICT ON UPDATE RESTRICT;
 
ALTER TABLE veiculo ADD CONSTRAINT FK_veiculo_2
    FOREIGN KEY (vei_fk_seguradora_pes_codigo???)
    REFERENCES ??? (???)
    ON DELETE RESTRICT ON UPDATE RESTRICT;
 
ALTER TABLE produto_frota ADD CONSTRAINT FK_produto_frota_1
    FOREIGN KEY (prf_fk_pro_codigo???)
    REFERENCES ??? (???)
    ON DELETE RESTRICT ON UPDATE RESTRICT;
 
ALTER TABLE produto_frota ADD CONSTRAINT FK_produto_frota_2
    FOREIGN KEY (prf_fk_cag_codigo)
    REFERENCES categoria_gasto (cag_codigo)
    ON DELETE RESTRICT ON UPDATE RESTRICT;
 
ALTER TABLE apontamento_veiculo_uso ADD CONSTRAINT FK_apontamento_veiculo_uso_1
    FOREIGN KEY (avu_fk_motorista_pes_codigo???)
    REFERENCES ??? (???);
 
ALTER TABLE apontamento_veiculo_uso ADD CONSTRAINT FK_apontamento_veiculo_uso_2
    FOREIGN KEY (avu_fk_vei_codigo)
    REFERENCES veiculo (vei_codigo);
 
ALTER TABLE apontamento_veiculo_gasto ADD CONSTRAINT FK_apontamento_veiculo_gasto_1
    FOREIGN KEY (avg_fk_vei_codigo)
    REFERENCES veiculo (vei_codigo)
    ON DELETE RESTRICT ON UPDATE RESTRICT;
 
ALTER TABLE apontamento_veiculo_gasto ADD CONSTRAINT FK_apontamento_veiculo_gasto_2
    FOREIGN KEY (avg_fk_responsavel_pes_codigo???)
    REFERENCES ??? (???)
    ON DELETE RESTRICT ON UPDATE RESTRICT;
 
ALTER TABLE apontamento_veiculo_gasto_item ADD CONSTRAINT FK_apontamento_veiculo_gasto_item_1
    FOREIGN KEY (avgi_fk_avg_codigo)
    REFERENCES apontamento_veiculo_gasto (avg_codigo)
    ON DELETE RESTRICT ON UPDATE RESTRICT;
 
ALTER TABLE apontamento_veiculo_gasto_item ADD CONSTRAINT FK_apontamento_veiculo_gasto_item_2
    FOREIGN KEY (avgi_fk_prf_codigo)
    REFERENCES produto_frota (prf_codigo)
    ON DELETE RESTRICT ON UPDATE RESTRICT;